package io.github.bymartrixx.vtd.gui.widget;

import com.mojang.blaze3d.systems.RenderSystem;
import net.minecraft.class_2585;
import net.minecraft.class_2960;
import net.minecraft.class_310;
import net.minecraft.class_332;
import net.minecraft.class_4185;
import net.minecraft.class_4587;

public class ArrowButtonWidget extends class_4185 {
    private static final class_2960 ARROWS_TEXTURE = new class_2960("textures/font/unicode_page_21.png");
    private final ArrowType arrowType;

    public ArrowButtonWidget(int x, int y, int width, int height, ArrowType arrowType, class_4241 onPress) {
        super(x, y, width, height, new class_2585(""), onPress);
        this.arrowType = arrowType;
    }

    private static void drawArrowTexture(class_4587 matrices, int x, int y, ArrowType arrowType, class_310 client) {
        client.method_1531().method_22813(ARROWS_TEXTURE);

        float u;
        float v;
        int textureXOffset = 4; // Center the texture in a 16 x 16 area
        switch (arrowType) {
            case CLOCKWISE:
                u = 176.0F;
                v = 176.0F;
                break;
            case LEFT:
                u = 96.0F;
                v = 224.0F;
                break;
            case RIGHT:
            default:
                u = 128.0F;
                v = 224.0F;
                break;
        }

        class_332.method_25290(matrices, x + textureXOffset + 2, y + 2, u, v, 16, 16, 256, 256);
    }

    @Override
    public void method_25359(class_4587 matrices, int mouseX, int mouseY, float delta) {
        class_310 minecraftClient = class_310.method_1551();
        minecraftClient.method_1531().method_22813(field_22757);

        RenderSystem.color4f(1.0F, 1.0F, 1.0F, this.field_22765);
        int i = this.method_25356(this.method_25367());
        RenderSystem.enableBlend();
        RenderSystem.defaultBlendFunc();
        RenderSystem.enableDepthTest();
        this.method_25302(matrices, this.field_22760, this.field_22761, 0, 46 + i * 20, this.field_22758 / 2, this.field_22759);
        this.method_25302(matrices, this.field_22760 + this.field_22758 / 2, this.field_22761, 200 - this.field_22758 / 2, 46 + i * 20, this.field_22758 / 2, this.field_22759);
        this.method_25353(matrices, minecraftClient, mouseX, mouseY);
        int j = this.field_22763 ? 16777215 : 10526880;

        ArrowButtonWidget.drawArrowTexture(matrices, this.field_22760, this.field_22761, arrowType, minecraftClient);
    }

    public enum ArrowType {
        CLOCKWISE,
        LEFT,
        RIGHT
    }
}
