package io.github.bymartrixx.vtd.gui.widget;

import com.google.gson.JsonArray;
import com.google.gson.JsonElement;
import com.google.gson.JsonObject;
import com.mojang.blaze3d.systems.RenderSystem;
import io.github.bymartrixx.vtd.VTDMod;
import io.github.bymartrixx.vtd.gui.VTDScreen;
import org.jetbrains.annotations.Nullable;

import java.util.ArrayList;
import java.util.Iterator;
import net.minecraft.class_124;
import net.minecraft.class_2561;
import net.minecraft.class_2585;
import net.minecraft.class_2588;
import net.minecraft.class_287;
import net.minecraft.class_289;
import net.minecraft.class_290;
import net.minecraft.class_332;
import net.minecraft.class_350;
import net.minecraft.class_3532;
import net.minecraft.class_4493;
import net.minecraft.class_4587;

public class PackListWidget extends class_350<PackListWidget.PackEntry> {
    public final String categoryName;
    public final boolean oneEntry; // If it should keep only one entry selected at once
    private final boolean displayEntries;

    public PackListWidget(JsonArray packs, String categoryName) {
        super(VTDScreen.getInstance().getClient(), VTDScreen.getInstance().field_22789 - 180, VTDScreen.getInstance().field_22790, 60, VTDScreen.getInstance().field_22790 - 40, 32);
        this.displayEntries = true;

        this.method_25315(true, 16);

        this.categoryName = categoryName;
        this.oneEntry = this.categoryName.equals("Menu Panoramas") || this.categoryName.equals("Options Background");

        for (int i = 0; i < packs.size(); ++i) {
            JsonObject pack = packs.get(i).getAsJsonObject();

            this.method_25321(new PackListWidget.PackEntry(pack));
        }
    }

    public PackListWidget() {
        super(VTDScreen.getInstance().getClient(), VTDScreen.getInstance().field_22789 - 180, VTDScreen.getInstance().field_22790, 60, VTDScreen.getInstance().field_22790 - 40, 32);
        this.displayEntries = false;
        this.categoryName = "Error!";
        this.oneEntry = false;
    }

    public int method_25322() {
        return this.field_22742 - 20;
    }

    protected int method_25329() {
        return this.field_22742 - 10;
    }

    // TODO: Incompatible packs warning

    public void setSelected(@Nullable PackListWidget.PackEntry entry) {
        this.setSelected(entry, true);
    }

    public void setSelected(@Nullable PackListWidget.PackEntry entry, boolean child) {
        if (entry == null) return;

        if (this.method_25396().contains(entry) || !child) {
            String packName = entry.name;
            if (!VTDScreen.getInstance().isPackSelected(this.categoryName, packName)) {
                VTDScreen.getInstance().addSelectedPack(this.categoryName, packName, this.oneEntry);
            } else {
                VTDScreen.getInstance().removeSelectedPack(this.categoryName, packName);
            }
        }
    }

    public boolean isSelected(PackListWidget.PackEntry entry) {
        if (!this.method_25396().contains(entry)) return false;

        return VTDScreen.getInstance().isPackSelected(this.categoryName, entry.name);
    }

    protected boolean method_25332(int index) {
        return this.isSelected(this.method_25396().get(index));
    }

    protected void method_25312(class_4587 matrices, int x, int y, class_289 tessellator) {
        class_2561 text = new class_2585(this.categoryName).method_27695(class_124.field_1067, class_124.field_1073);
        VTDScreen.getInstance().getTextRenderer().method_30883(matrices, text, ((float) (this.field_22742 / 2 - VTDScreen.getInstance().getTextRenderer().method_27525(text) / 2)), Math.min(this.field_19085 + 3, y), 16777215);
    }

    public void method_25394(class_4587 matrices, int mouseX, int mouseY, float delta) {
        if (this.displayEntries) {
//            super.render(matrices, mouseX, mouseY, delta);

            // Cursed fix for #2, TODO: Remove
            this.method_25325(matrices);
            int i = this.method_25329();
            int j = i + 6;
            class_289 tessellator = class_289.method_1348();
            class_287 bufferBuilder = tessellator.method_1349();
//            if (this.field_26846) { // Private field, true
                this.field_22740.method_1531().method_22813(class_332.field_22735);
                RenderSystem.color4f(1.0F, 1.0F, 1.0F, 1.0F);
                float f = 32.0F;
                bufferBuilder.method_1328(7, class_290.field_1575);
                bufferBuilder.method_22912(this.field_19088, this.field_19086, 0.0D).method_22913((float)this.field_19088 / 32.0F, (float)(this.field_19086 + (int)this.method_25341()) / 32.0F).method_1336(32, 32, 32, 255).method_1344();
                bufferBuilder.method_22912(this.field_19087, this.field_19086, 0.0D).method_22913((float)this.field_19087 / 32.0F, (float)(this.field_19086 + (int)this.method_25341()) / 32.0F).method_1336(32, 32, 32, 255).method_1344();
                bufferBuilder.method_22912(this.field_19087, this.field_19085, 0.0D).method_22913((float)this.field_19087 / 32.0F, (float)(this.field_19085 + (int)this.method_25341()) / 32.0F).method_1336(32, 32, 32, 255).method_1344();
                bufferBuilder.method_22912(this.field_19088, this.field_19085, 0.0D).method_22913((float)this.field_19088 / 32.0F, (float)(this.field_19085 + (int)this.method_25341()) / 32.0F).method_1336(32, 32, 32, 255).method_1344();
                tessellator.method_1350();
//            }

            int k = this.method_25342();
            int l = this.field_19085 + 4 - (int)this.method_25341();
//            if (this.renderHeader) { // Private field, true
                this.method_25312(matrices, k, l, tessellator);
//            }

            this.method_25311(matrices, k, l, mouseX, mouseY, delta);
//            if (this.field_26847) { // Private field, true
                this.field_22740.method_1531().method_22813(class_332.field_22735);
                RenderSystem.enableDepthTest();
                RenderSystem.depthFunc(519);
                float g = 32.0F;
//                int m = true; // What
                bufferBuilder.method_1328(7, class_290.field_1575);
                bufferBuilder.method_22912(this.field_19088, this.field_19085, -100.0D).method_22913(0.0F, (float)this.field_19085 / 32.0F).method_1336(64, 64, 64, 255).method_1344();
                bufferBuilder.method_22912((this.field_19088 + this.field_22742), this.field_19085, -100.0D).method_22913((float)this.field_22742 / 32.0F, (float)this.field_19085 / 32.0F).method_1336(64, 64, 64, 255).method_1344();
                bufferBuilder.method_22912((this.field_19088 + this.field_22742), 0.0D, -100.0D).method_22913((float)this.field_22742 / 32.0F, 0.0F).method_1336(64, 64, 64, 255).method_1344();
                bufferBuilder.method_22912(this.field_19088, 0.0D, -100.0D).method_22913(0.0F, 0.0F).method_1336(64, 64, 64, 255).method_1344();
                bufferBuilder.method_22912(this.field_19088, this.field_22743, -100.0D).method_22913(0.0F, (float)this.field_22743 / 32.0F).method_1336(64, 64, 64, 255).method_1344();
                bufferBuilder.method_22912((this.field_19088 + this.field_22742), this.field_22743, -100.0D).method_22913((float)this.field_22742 / 32.0F, (float)this.field_22743 / 32.0F).method_1336(64, 64, 64, 255).method_1344();
                bufferBuilder.method_22912((this.field_19088 + this.field_22742), this.field_19086, -100.0D).method_22913((float)this.field_22742 / 32.0F, (float)this.field_19086 / 32.0F).method_1336(64, 64, 64, 255).method_1344();
                bufferBuilder.method_22912(this.field_19088, this.field_19086, -100.0D).method_22913(0.0F, (float)this.field_19086 / 32.0F).method_1336(64, 64, 64, 255).method_1344();
                tessellator.method_1350();
                RenderSystem.depthFunc(515);
                RenderSystem.disableDepthTest();
                RenderSystem.enableBlend();
                RenderSystem.blendFuncSeparate(class_4493.class_4535.field_22541, class_4493.class_4534.field_22523, class_4493.class_4535.field_22544, class_4493.class_4534.field_22518);
                RenderSystem.disableAlphaTest();
                RenderSystem.shadeModel(7425);
                RenderSystem.disableTexture();
//                int n = true; What
                bufferBuilder.method_1328(7, class_290.field_1575);
                bufferBuilder.method_22912(this.field_19088, (this.field_19085 + 4), 0.0D).method_22913(0.0F, 1.0F).method_1336(0, 0, 0, 0).method_1344();
                bufferBuilder.method_22912(this.field_19087, (this.field_19085 + 4), 0.0D).method_22913(1.0F, 1.0F).method_1336(0, 0, 0, 0).method_1344();
                bufferBuilder.method_22912(this.field_19087, this.field_19085, 0.0D).method_22913(1.0F, 0.0F).method_1336(0, 0, 0, 255).method_1344();
                bufferBuilder.method_22912(this.field_19088, this.field_19085, 0.0D).method_22913(0.0F, 0.0F).method_1336(0, 0, 0, 255).method_1344();
                bufferBuilder.method_22912(this.field_19088, this.field_19086, 0.0D).method_22913(0.0F, 1.0F).method_1336(0, 0, 0, 255).method_1344();
                bufferBuilder.method_22912(this.field_19087, this.field_19086, 0.0D).method_22913(1.0F, 1.0F).method_1336(0, 0, 0, 255).method_1344();
                bufferBuilder.method_22912(this.field_19087, (this.field_19086 - 4), 0.0D).method_22913(1.0F, 0.0F).method_1336(0, 0, 0, 0).method_1344();
                bufferBuilder.method_22912(this.field_19088, (this.field_19086 - 4), 0.0D).method_22913(0.0F, 0.0F).method_1336(0, 0, 0, 0).method_1344();
                tessellator.method_1350();
//            }

            int o = this.method_25331();
            if (o > 0) {
                RenderSystem.disableTexture();
                int p = (int)((float)((this.field_19086 - this.field_19085) * (this.field_19086 - this.field_19085)) / (float)this.method_25317());
                p = class_3532.method_15340(p, 32, this.field_19086 - this.field_19085 - 8);
                int q = (int)this.method_25341() * (this.field_19086 - this.field_19085 - p) / o + this.field_19085;
                if (q < this.field_19085) {
                    q = this.field_19085;
                }

                bufferBuilder.method_1328(7, class_290.field_1575);
                bufferBuilder.method_22912(i, this.field_19086, 0.0D).method_22913(0.0F, 1.0F).method_1336(0, 0, 0, 255).method_1344();
                bufferBuilder.method_22912(j, this.field_19086, 0.0D).method_22913(1.0F, 1.0F).method_1336(0, 0, 0, 255).method_1344();
                bufferBuilder.method_22912(j, this.field_19085, 0.0D).method_22913(1.0F, 0.0F).method_1336(0, 0, 0, 255).method_1344();
                bufferBuilder.method_22912(i, this.field_19085, 0.0D).method_22913(0.0F, 0.0F).method_1336(0, 0, 0, 255).method_1344();
                bufferBuilder.method_22912(i, (q + p), 0.0D).method_22913(0.0F, 1.0F).method_1336(128, 128, 128, 255).method_1344();
                bufferBuilder.method_22912(j, (q + p), 0.0D).method_22913(1.0F, 1.0F).method_1336(128, 128, 128, 255).method_1344();
                bufferBuilder.method_22912(j, q, 0.0D).method_22913(1.0F, 0.0F).method_1336(128, 128, 128, 255).method_1344();
                bufferBuilder.method_22912(i, q, 0.0D).method_22913(0.0F, 0.0F).method_1336(128, 128, 128, 255).method_1344();
                bufferBuilder.method_22912(i, (q + p - 1), 0.0D).method_22913(0.0F, 1.0F).method_1336(192, 192, 192, 255).method_1344();
                bufferBuilder.method_22912((j - 1), (q + p - 1), 0.0D).method_22913(1.0F, 1.0F).method_1336(192, 192, 192, 255).method_1344();
                bufferBuilder.method_22912((j - 1), q, 0.0D).method_22913(1.0F, 0.0F).method_1336(192, 192, 192, 255).method_1344();
                bufferBuilder.method_22912(i, q, 0.0D).method_22913(0.0F, 0.0F).method_1336(192, 192, 192, 255).method_1344();
                tessellator.method_1350();
            }

            this.method_25320(matrices, mouseX, mouseY);
            RenderSystem.enableTexture();
            RenderSystem.shadeModel(7424);
            RenderSystem.enableAlphaTest();
            RenderSystem.disableBlend();
            // End of cursed fix for #2
        } else {
            class_2561 msgHeader = new class_2588("vtd.packError.title.1").method_27695(class_124.field_1067, class_124.field_1056);
            class_2561 msgHeader2 = new class_2588("vtd.packError.title.2").method_27695(class_124.field_1067, class_124.field_1056);
            class_2561 msgBody = new class_2588("vtd.packError.body.1");
            class_2561 msgBody2 = new class_2588("vtd.packError.body.2");
            class_2561 msgBody3 = new class_2588("vtd.packError.body.3", VTDMod.BASE_URL);

            VTDScreen.getInstance().getTextRenderer().method_30883(matrices, msgHeader, ((float) (this.field_22742 / 2 - VTDScreen.getInstance().getTextRenderer().method_27525(msgHeader) / 2)), ((float) (this.field_22743 / 2) - 32), 16777215);
            VTDScreen.getInstance().getTextRenderer().method_30883(matrices, msgHeader2, ((float) (this.field_22742 / 2 - VTDScreen.getInstance().getTextRenderer().method_27525(msgHeader2) / 2)), ((float) (this.field_22743 / 2) - 16), 16777215);
            VTDScreen.getInstance().getTextRenderer().method_30883(matrices, msgBody, ((float) (this.field_22742 / 2 - VTDScreen.getInstance().getTextRenderer().method_27525(msgBody) / 2)), ((float) (this.field_22743 / 2)), 16777215);
            VTDScreen.getInstance().getTextRenderer().method_30883(matrices, msgBody2, ((float) (this.field_22742 / 2 - VTDScreen.getInstance().getTextRenderer().method_27525(msgBody2) / 2)), ((float) (this.field_22743 / 2) + 16), 16777215);
            VTDScreen.getInstance().getTextRenderer().method_30883(matrices, msgBody3, ((float) (this.field_22742 / 2 - VTDScreen.getInstance().getTextRenderer().method_27525(msgBody3) / 2)), ((float) (this.field_22743 / 2) + 32), 16777215);
        }
    }

    public class PackEntry extends class_350.class_351<PackListWidget.PackEntry> {
        public final String name;
        public final String displayName;
        public final String description;
        public final String[] incompatiblePacks;

        PackEntry(JsonObject pack) {
            this.name = pack.get("name").getAsString();

            this.displayName = pack.get("display").getAsString();
            this.description = pack.get("description").getAsString();

            Iterator<JsonElement> incompatiblePacksIterator = pack.get("incompatible").getAsJsonArray().iterator();
            ArrayList<String> incompatiblePacks = new ArrayList<>();

            while (incompatiblePacksIterator.hasNext()) {
                incompatiblePacks.add(incompatiblePacksIterator.next().getAsString());
            }

            this.incompatiblePacks = incompatiblePacks.toArray(new String[0]);
        }

        public boolean method_25402(double mouseX, double mouseY, int button) {
            if (button == 0) {
                this.setSelected();
            }

            return false;
        }

        private void setSelected() {
            PackListWidget.this.setSelected(this);
        }

        public void method_25343(class_4587 matrices, int index, int y, int x, int entryWidth, int entryHeight, int mouseX, int mouseY, boolean hovered, float tickDelta) {
            VTDScreen.getInstance().getTextRenderer().method_1720(matrices, this.displayName, ((float) (PackListWidget.this.field_22742 / 2 - VTDScreen.getInstance().getTextRenderer().method_1727(this.displayName) / 2)), y + 1, 16777215);
            this.renderDescription(matrices, y);
        }

        private void renderDescription(class_4587 matrices, int y) {
            int textWidth = VTDScreen.getInstance().getTextRenderer().method_1727(this.description);
            int maxWidth = Math.min(280, PackListWidget.this.method_25322() - 4);

            if (textWidth > maxWidth) {
                String description = VTDScreen.getInstance().getTextRenderer().method_27523(this.description, maxWidth - VTDScreen.getInstance().getTextRenderer().method_1727("...")) + "...";
                VTDScreen.getInstance().getTextRenderer().method_1720(matrices, description, ((float) (PackListWidget.this.field_22742 / 2 - VTDScreen.getInstance().getTextRenderer().method_1727(description) / 2)), y + 13, 16777215);
            } else {
                VTDScreen.getInstance().getTextRenderer().method_1720(matrices, this.description, ((float) (PackListWidget.this.field_22742 / 2 - VTDScreen.getInstance().getTextRenderer().method_1727(this.description) / 2)), y + 13, 16777215);
            }
        }

        @Override
        public boolean equals(Object obj) {
            if (obj instanceof String) {
                return equals((String) obj);
            }

            return super.equals(obj);
        }

        public boolean equals(String packName) {
            return this.name.equals(packName);
        }
    }
}
