package io.github.bymartrixx.vtd.gui.widget;

import com.google.gson.JsonArray;
import com.google.gson.JsonElement;
import com.google.gson.JsonObject;
import com.mojang.blaze3d.systems.RenderSystem;
import io.github.bymartrixx.vtd.VTDMod;
import io.github.bymartrixx.vtd.gui.VTDScreen;
import java.util.*;
import net.minecraft.class_124;
import net.minecraft.class_2561;
import net.minecraft.class_2588;
import net.minecraft.class_287;
import net.minecraft.class_289;
import net.minecraft.class_290;
import net.minecraft.class_2960;
import net.minecraft.class_332;
import net.minecraft.class_350;
import net.minecraft.class_3532;
import net.minecraft.class_4493;
import net.minecraft.class_4587;

public class SelectedPacksListWidget extends class_350<SelectedPacksListWidget.Entry> {
    private static final class_2960 RESOURCE_PACKS_TEXTURE = new class_2960("textures/gui/resource_packs.png");

    public SelectedPacksListWidget() {
        super(VTDScreen.getInstance().getClient(), 160, VTDScreen.getInstance().field_22790, 80, VTDScreen.getInstance().field_22790 - 60, 16);
        this.method_25315(true, 16);

        this.updateEntries();
    }

    public int method_25322() {
        return this.field_22742 - 20;
    }

    protected int method_25329() {
        return this.method_31383(); // this.getRowLeft() + this.getRowWidth();
    }

    protected void method_25312(class_4587 matrices, int x, int y, class_289 tessellator) {
        class_2561 text = new class_2588("vtd.selectedPacks").method_27695(class_124.field_1067, class_124.field_1073);
        VTDScreen.getInstance().getTextRenderer().method_30883(matrices, text, ((float) (this.field_22742 / 2 - VTDScreen.getInstance().getTextRenderer().method_27525(text) / 2) + (VTDScreen.getInstance().field_22789 - 170)), Math.min(this.field_19085 + 3, y), 16777215);
    }

    public void updateEntries() {
        this.method_25396().clear();

        JsonObject selectedPacks = VTDMod.GSON.toJsonTree(VTDScreen.getInstance().selectedPacks).getAsJsonObject();
        Set<Map.Entry<String, JsonElement>> selectedPacksCategories = selectedPacks.entrySet();

        for (Map.Entry<String, JsonElement> category : selectedPacksCategories) {
            String categoryName = category.getKey();
            JsonArray packs = category.getValue().getAsJsonArray();

            this.method_25321(new Entry(this, true, categoryName));

            for (int i = 0; i < packs.size(); ++i) {
                String pack = packs.get(i).getAsString();

                this.method_25321(new Entry(this, false, categoryName, pack));
            }
        }

        this.method_25307(this.method_25341()); // Update scrollbar
    }

    /**
     * A cursed fix to #2. Bedrockify mixins into
     * {@link class_350#method_25394(class_4587, int, int, float)} and "disables" calls to
     * {@link #method_25325(class_4587)}. In order to "enable" it again, I have copied
     * the method and, because it's a different method on a different class Bedrockify won't
     * affect it with a mixin.
     */
    @Deprecated
    @Override
    public void method_25394(class_4587 matrices, int mouseX, int mouseY, float delta) {
        this.method_25325(matrices);
        int i = this.method_25329();
        int j = i + 6;
        class_289 tessellator = class_289.method_1348();
        class_287 bufferBuilder = tessellator.method_1349();
//        if (this.field_26846) { // Private field, true
        this.field_22740.method_1531().method_22813(class_332.field_22735);
        RenderSystem.color4f(1.0F, 1.0F, 1.0F, 1.0F);
        float f = 32.0F;
        bufferBuilder.method_1328(7, class_290.field_1575);
        bufferBuilder.method_22912(this.field_19088, this.field_19086, 0.0D).method_22913((float)this.field_19088 / 32.0F, (float)(this.field_19086 + (int)this.method_25341()) / 32.0F).method_1336(32, 32, 32, 255).method_1344();
        bufferBuilder.method_22912(this.field_19087, this.field_19086, 0.0D).method_22913((float)this.field_19087 / 32.0F, (float)(this.field_19086 + (int)this.method_25341()) / 32.0F).method_1336(32, 32, 32, 255).method_1344();
        bufferBuilder.method_22912(this.field_19087, this.field_19085, 0.0D).method_22913((float)this.field_19087 / 32.0F, (float)(this.field_19085 + (int)this.method_25341()) / 32.0F).method_1336(32, 32, 32, 255).method_1344();
        bufferBuilder.method_22912(this.field_19088, this.field_19085, 0.0D).method_22913((float)this.field_19088 / 32.0F, (float)(this.field_19085 + (int)this.method_25341()) / 32.0F).method_1336(32, 32, 32, 255).method_1344();
        tessellator.method_1350();
//        }

        int k = this.method_25342();
        int l = this.field_19085 + 4 - (int)this.method_25341();
//        if (this.renderHeader) { // Private field, true
        this.method_25312(matrices, k, l, tessellator);
//        }

        this.method_25311(matrices, k, l, mouseX, mouseY, delta);
//        if (this.field_26847) { // Private field, true
        this.field_22740.method_1531().method_22813(class_332.field_22735);
        RenderSystem.enableDepthTest();
        RenderSystem.depthFunc(519);
        float g = 32.0F;
//            int m = true; // What
        bufferBuilder.method_1328(7, class_290.field_1575);
        bufferBuilder.method_22912(this.field_19088, this.field_19085, -100.0D).method_22913(0.0F, (float)this.field_19085 / 32.0F).method_1336(64, 64, 64, 255).method_1344();
        bufferBuilder.method_22912((this.field_19088 + this.field_22742), this.field_19085, -100.0D).method_22913((float)this.field_22742 / 32.0F, (float)this.field_19085 / 32.0F).method_1336(64, 64, 64, 255).method_1344();
        bufferBuilder.method_22912((this.field_19088 + this.field_22742), 0.0D, -100.0D).method_22913((float)this.field_22742 / 32.0F, 0.0F).method_1336(64, 64, 64, 255).method_1344();
        bufferBuilder.method_22912(this.field_19088, 0.0D, -100.0D).method_22913(0.0F, 0.0F).method_1336(64, 64, 64, 255).method_1344();
        bufferBuilder.method_22912(this.field_19088, this.field_22743, -100.0D).method_22913(0.0F, (float)this.field_22743 / 32.0F).method_1336(64, 64, 64, 255).method_1344();
        bufferBuilder.method_22912((this.field_19088 + this.field_22742), this.field_22743, -100.0D).method_22913((float)this.field_22742 / 32.0F, (float)this.field_22743 / 32.0F).method_1336(64, 64, 64, 255).method_1344();
        bufferBuilder.method_22912((this.field_19088 + this.field_22742), this.field_19086, -100.0D).method_22913((float)this.field_22742 / 32.0F, (float)this.field_19086 / 32.0F).method_1336(64, 64, 64, 255).method_1344();
        bufferBuilder.method_22912(this.field_19088, this.field_19086, -100.0D).method_22913(0.0F, (float)this.field_19086 / 32.0F).method_1336(64, 64, 64, 255).method_1344();
        tessellator.method_1350();
        RenderSystem.depthFunc(515);
        RenderSystem.disableDepthTest();
        RenderSystem.enableBlend();
        RenderSystem.blendFuncSeparate(class_4493.class_4535.field_22541, class_4493.class_4534.field_22523, class_4493.class_4535.field_22544, class_4493.class_4534.field_22518);
        RenderSystem.disableAlphaTest();
        RenderSystem.shadeModel(7425);
        RenderSystem.disableTexture();
//            int n = true; What
        bufferBuilder.method_1328(7, class_290.field_1575);
        bufferBuilder.method_22912(this.field_19088, (this.field_19085 + 4), 0.0D).method_22913(0.0F, 1.0F).method_1336(0, 0, 0, 0).method_1344();
        bufferBuilder.method_22912(this.field_19087, (this.field_19085 + 4), 0.0D).method_22913(1.0F, 1.0F).method_1336(0, 0, 0, 0).method_1344();
        bufferBuilder.method_22912(this.field_19087, this.field_19085, 0.0D).method_22913(1.0F, 0.0F).method_1336(0, 0, 0, 255).method_1344();
        bufferBuilder.method_22912(this.field_19088, this.field_19085, 0.0D).method_22913(0.0F, 0.0F).method_1336(0, 0, 0, 255).method_1344();
        bufferBuilder.method_22912(this.field_19088, this.field_19086, 0.0D).method_22913(0.0F, 1.0F).method_1336(0, 0, 0, 255).method_1344();
        bufferBuilder.method_22912(this.field_19087, this.field_19086, 0.0D).method_22913(1.0F, 1.0F).method_1336(0, 0, 0, 255).method_1344();
        bufferBuilder.method_22912(this.field_19087, (this.field_19086 - 4), 0.0D).method_22913(1.0F, 0.0F).method_1336(0, 0, 0, 0).method_1344();
        bufferBuilder.method_22912(this.field_19088, (this.field_19086 - 4), 0.0D).method_22913(0.0F, 0.0F).method_1336(0, 0, 0, 0).method_1344();
        tessellator.method_1350();
//        }

        int o = this.method_25331();
        if (o > 0) {
            RenderSystem.disableTexture();
            int p = (int)((float)((this.field_19086 - this.field_19085) * (this.field_19086 - this.field_19085)) / (float)this.method_25317());
            p = class_3532.method_15340(p, 32, this.field_19086 - this.field_19085 - 8);
            int q = (int)this.method_25341() * (this.field_19086 - this.field_19085 - p) / o + this.field_19085;
            if (q < this.field_19085) {
                q = this.field_19085;
            }

            bufferBuilder.method_1328(7, class_290.field_1575);
            bufferBuilder.method_22912(i, this.field_19086, 0.0D).method_22913(0.0F, 1.0F).method_1336(0, 0, 0, 255).method_1344();
            bufferBuilder.method_22912(j, this.field_19086, 0.0D).method_22913(1.0F, 1.0F).method_1336(0, 0, 0, 255).method_1344();
            bufferBuilder.method_22912(j, this.field_19085, 0.0D).method_22913(1.0F, 0.0F).method_1336(0, 0, 0, 255).method_1344();
            bufferBuilder.method_22912(i, this.field_19085, 0.0D).method_22913(0.0F, 0.0F).method_1336(0, 0, 0, 255).method_1344();
            bufferBuilder.method_22912(i, (q + p), 0.0D).method_22913(0.0F, 1.0F).method_1336(128, 128, 128, 255).method_1344();
            bufferBuilder.method_22912(j, (q + p), 0.0D).method_22913(1.0F, 1.0F).method_1336(128, 128, 128, 255).method_1344();
            bufferBuilder.method_22912(j, q, 0.0D).method_22913(1.0F, 0.0F).method_1336(128, 128, 128, 255).method_1344();
            bufferBuilder.method_22912(i, q, 0.0D).method_22913(0.0F, 0.0F).method_1336(128, 128, 128, 255).method_1344();
            bufferBuilder.method_22912(i, (q + p - 1), 0.0D).method_22913(0.0F, 1.0F).method_1336(192, 192, 192, 255).method_1344();
            bufferBuilder.method_22912((j - 1), (q + p - 1), 0.0D).method_22913(1.0F, 1.0F).method_1336(192, 192, 192, 255).method_1344();
            bufferBuilder.method_22912((j - 1), q, 0.0D).method_22913(1.0F, 0.0F).method_1336(192, 192, 192, 255).method_1344();
            bufferBuilder.method_22912(i, q, 0.0D).method_22913(0.0F, 0.0F).method_1336(192, 192, 192, 255).method_1344();
            tessellator.method_1350();
        }

        this.method_25320(matrices, mouseX, mouseY);
        RenderSystem.enableTexture();
        RenderSystem.shadeModel(7424);
        RenderSystem.enableAlphaTest();
        RenderSystem.disableBlend();
    }

    public class Entry extends class_350.class_351<SelectedPacksListWidget.Entry> {
        /**
         * If the entry is a category or a pack under one category.
         */
        public final boolean isCategory;
        /**
         * If {@link #isCategory} is true, the name of the category, if it is false, the name of the parent category.
         */
        public final String categoryName;
        private final SelectedPacksListWidget widget;
        /**
         * If {@link #isCategory} is false, keeps the name of the pack.
         * Use {@link #getPackName()} to get the value.
         */
        private String packName = "";

        Entry(SelectedPacksListWidget widget, boolean isCategory, String categoryName, String packName) {
            this(widget, isCategory, categoryName);
            this.packName = packName;
        }

        Entry(SelectedPacksListWidget widget, boolean isCategory, String categoryName) {
            this.widget = widget;
            this.isCategory = isCategory;
            this.categoryName = categoryName;
        }

        /**
         * @return the pack name if {@link #isCategory} is false, or {@code ""} if it is true.
         */
        @SuppressWarnings("unused")
        public String getPackName() {
            return packName;
        }

        public void method_25343(class_4587 matrices, int index, int y, int x, int entryWidth, int entryHeight, int mouseX, int mouseY, boolean hovered, float tickDelta) {
            if (hovered) {
                method_25294(matrices, x, y, x + entryWidth, y + 16, -1601138544);
            }

            String text = this.isCategory ? this.categoryName : this.packName;
            int textWidth = VTDScreen.getInstance().getTextRenderer().method_1727(text);

            if (textWidth > this.widget.method_25322() - (this.isCategory ? 24 : 36)) {
                text = VTDScreen.getInstance().getTextRenderer().method_27523(text, this.widget.method_25322() - (this.isCategory ? 24 : 36) - VTDScreen.getInstance().getTextRenderer().method_1727("...")) + "...";
            }

            VTDScreen.getInstance().getTextRenderer().method_1720(matrices, text, x + (this.isCategory ? 4 : 16), y + 4, 16777215);

            // Render up/down buttons
            if (hovered) {
                int localMouseX = mouseX - x;
                int localMouseY = mouseY - y;

                VTDScreen.getInstance().getClient().method_1531().method_22813(RESOURCE_PACKS_TEXTURE);

                if (this.canMoveUp()) {
                    if (localMouseX > entryWidth - 8 && localMouseY < 8) {
                        class_332.method_25293(matrices, x + entryWidth - 16, y, 16, 16, 96.0F, 32.0F, 32, 32, 256, 256);
                    } else {
                        class_332.method_25293(matrices, x + entryWidth - 16, y, 16, 16, 96.0F, 0.0F, 32, 32, 256, 256);
                    }
                }

                if (this.canMoveDown()) {
                    if (localMouseX > entryWidth - 8 && localMouseY > 8) {
                        class_332.method_25293(matrices, x + entryWidth - 16, y, 16, 16, 64.0F, 32.0F, 32, 32, 256, 256);
                    } else {
                        class_332.method_25293(matrices, x + entryWidth - 16, y, 16, 16, 64.0F, 0.0F, 32, 32, 256, 256);
                    }
                }
            }
        }

        public boolean method_25402(double mouseX, double mouseY, int button) {
            double x = mouseX - this.widget.method_25342();
            double y = mouseY - this.widget.method_25337(this.widget.method_25396().indexOf(this));

            if (x > this.widget.method_25322() - 8) {
                if (y < 8 && this.canMoveUp()) {
                    this.moveUp();
                    this.widget.updateEntries();
                    return true;
                }

                if (y > 8 && this.canMoveDown()) {
                    this.moveDown();
                    this.widget.updateEntries();
                    return true;
                }
            }

            return false;
        }

        private boolean canMoveUp() {
            if (this.isCategory) {
                return !VTDScreen.getInstance().selectedPacks.keySet().toArray()[0].equals(this.categoryName);
            } else {
                return !VTDScreen.getInstance().selectedPacks.get(this.categoryName).toArray()[0].equals(this.packName);
            }
        }

        private boolean canMoveDown() {
            if (this.isCategory) {
                Object[] categories = VTDScreen.getInstance().selectedPacks.keySet().toArray();
                return !categories[categories.length - 1].equals(this.categoryName);
            } else {
                Object[] packs = VTDScreen.getInstance().selectedPacks.get(this.categoryName).toArray();
                return !packs[packs.length - 1].equals(this.packName);
            }
        }

        private void moveUp() {
            if (this.isCategory) {
                Map<String, List<String>> selectedPacks = VTDScreen.getInstance().selectedPacks;
                Iterator<String> categoriesIterator = selectedPacks.keySet().iterator();

                String previousCategoryName = "";
                // Save previous category name, if this category name is found, keep previous category name
                while (categoriesIterator.hasNext()) {
                    String categoryName = categoriesIterator.next();

                    if (categoryName.equals(this.categoryName)) {
                        break;
                    }

                    previousCategoryName = categoryName;
                }

                if (!previousCategoryName.equals("")) {
                    Map<String, List<String>> newSelectedPacks = new LinkedHashMap<>();

                    // Copy values to new map, where the order is changed
                    // When the previous entry is found, put this entry (in the place of the previous entry), skip, and put the previous entry
                    for (int i = 0; i < selectedPacks.size(); ++i) {
                        String categoryName = (String) selectedPacks.keySet().toArray()[i];

                        if (!categoryName.equals(previousCategoryName)) {
                            newSelectedPacks.put(categoryName, selectedPacks.get(categoryName));
                        } else {
                            newSelectedPacks.put(this.categoryName, selectedPacks.get(this.categoryName)); // Put this entry
                            ++i; // Skip
                            newSelectedPacks.put(previousCategoryName, selectedPacks.get(previousCategoryName)); // Put the previous entry
                        }
                    }

                    VTDScreen.getInstance().selectedPacks.clear();
                    VTDScreen.getInstance().selectedPacks.putAll(newSelectedPacks);
                }
            } else {
                List<String> selectedPacksOfCategory = VTDScreen.getInstance().selectedPacks.get(this.categoryName);
                Iterator<String> packsIterator = selectedPacksOfCategory.iterator();

                String previousPackName = "";
                // Save previous category name, if this category name is found, keep previous category name
                while (packsIterator.hasNext()) {
                    String packName = packsIterator.next();

                    if (packName.equals(this.packName)) {
                        break;
                    }

                    previousPackName = packName;
                }

                if (!previousPackName.equals("")) {
                    List<String> newSelectedPacksOfCategory = new ArrayList<>();

                    // Copy values to new list, where the order is changed
                    // When the previous entry is found, put this entry (in the place of the previous entry), skip, and put the previous entry
                    for (int i = 0; i < selectedPacksOfCategory.size(); ++i) {
                        String packName = selectedPacksOfCategory.get(i);

                        if (!packName.equals(previousPackName)) {
                            newSelectedPacksOfCategory.add(packName);
                        } else {
                            newSelectedPacksOfCategory.add(this.packName); // Put this entry
                            ++i; // Skip
                            newSelectedPacksOfCategory.add(previousPackName); // Put the previous entry
                        }
                    }

                    VTDScreen.getInstance().selectedPacks.replace(this.categoryName, newSelectedPacksOfCategory);
                }
            }
        }

        private void moveDown() {
            if (this.isCategory) {
                Map<String, List<String>> selectedPacks = VTDScreen.getInstance().selectedPacks;
                Iterator<String> categoriesIterator = selectedPacks.keySet().iterator();

                String nextCategoryName = "";
                while (categoriesIterator.hasNext()) {
                    String categoryName = categoriesIterator.next();

                    if (categoryName.equals(this.categoryName)) {
                        nextCategoryName = categoriesIterator.next();
                        break;
                    }
                }

                if (!nextCategoryName.equals("")) {
                    Map<String, List<String>> newSelectedPacks = new LinkedHashMap<>();

                    // Copy values to new map, where the order is changed
                    // When this entry is found, put next entry (in the place of this entry), skip, and put this entry
                    for (int i = 0; i < selectedPacks.size(); ++i) {
                        String categoryName = (String) selectedPacks.keySet().toArray()[i];

                        if (!categoryName.equals(this.categoryName)) {
                            newSelectedPacks.put(categoryName, selectedPacks.get(categoryName));
                        } else {
                            newSelectedPacks.put(nextCategoryName, selectedPacks.get(nextCategoryName)); // Put next entry
                            ++i; // Skip
                            newSelectedPacks.put(this.categoryName, selectedPacks.get(this.categoryName)); // Put this entry
                        }
                    }

                    VTDScreen.getInstance().selectedPacks.clear();
                    VTDScreen.getInstance().selectedPacks.putAll(newSelectedPacks);
                }
            } else {
                List<String> selectedPacksOfCategory = VTDScreen.getInstance().selectedPacks.get(this.categoryName);
                Iterator<String> packsIterator = selectedPacksOfCategory.iterator();

                String nextPackName = "";
                while (packsIterator.hasNext()) {
                    String packName = packsIterator.next();

                    if (packName.equals(this.packName)) {
                        nextPackName = packsIterator.next();
                        break;
                    }
                }

                if (!nextPackName.equals("")) {
                    List<String> newSelectedPacksOfCategory = new ArrayList<>();

                    // Copy values to new list, where the order is changed
                    // When this entry is found, put next entry (in the place of this entry), skip, and put this entry
                    for (int i = 0; i < selectedPacksOfCategory.size(); ++i) {
                        String packName = selectedPacksOfCategory.get(i);

                        if (!packName.equals(this.packName)) {
                            newSelectedPacksOfCategory.add(packName);
                        } else {
                            newSelectedPacksOfCategory.add(nextPackName); // Put next entry
                            ++i; // Skip
                            newSelectedPacksOfCategory.add(this.packName); // Put this entry
                        }
                    }

                    VTDScreen.getInstance().selectedPacks.replace(this.categoryName, newSelectedPacksOfCategory);
                }
            }
        }
    }
}
